Description

This is just a "wishlist" feature request.

I've been enjoying to learn to use the methods for FHICL validation. Eg, based on "art::ToolConfigTable<>" as discussed recently on
the larsoft list.

And | like how the small effort to define the needed C++ struct gives other benifits like fleshing out the output of “art --print-description
MyTool" with useful information for the user.

This would be even more useful to the user if the developer could associate some short docstrings to each declared entry in the C++
struct so that they could then also be printed.

My naive suggestion is to allow an optional, second argument to “fhicl::Name()" which might be used like:
struct Config {
typedef fhicl::Sequence<std::string> string_list_t;
string_list_t paths { fhicl::Name ("paths", "List of paths in which to search for files") };

and then instrument whatever streamer produces the --print-description to include any docstrings. (maybe something in art?).

Thanks for consideration.

History

#1 - 07/07/2017 10:53 AM - Kyle Knoepfel

- Description updated

#2 - 07/07/2017 10:56 AM - Kyle Knoepfel
- Status changed from New to Feedback
You should be able to add a fhicl::Comment to any of the fhiclcpp types. For example:
struct Config {
typedef fhicl::Sequence<std::string> string_ list_t;
string_list_t paths { fhicl::Name ("paths"), fhicl::Comment ("List of paths in which to search for files") };
}
The comment is then printed out above the parameter whenever --print-description is invoked.
Does this meet the need?

#3 - 07/07/2017 10:58 AM - Brett Viren

Wow, you are fast! Yes, this is perfect. Sorry for the noise of this ticket.

#4 - 07/10/2017 11:29 AM - Kyle Knoepfel
- Status changed from Feedback to Resolved

- % Done changed from 0 to 100

#5 - 07/10/2017 11:30 AM - Kyle Knoepfel

- Tracker changed from Feature to Support
- Status changed from Resolved to Closed
